=== test/integration/CMakeLists.txt ===
# =============================================================================
# Add extra compile flags to NMODL test sources
# =============================================================================
add_compile_options(${NMODL_EXTRA_CXX_FLAGS})
add_link_options(${NMODL_EXTRA_CXX_FLAGS})

# =============================================================================
# translation of mod files
# =============================================================================
file(GLOB modfiles "${NMODL_PROJECT_SOURCE_DIR}/test/integration/mod/*.mod")
foreach(modfile ${modfiles})
  get_filename_component(modfile_name "${modfile}" NAME)
  add_test(NAME ${modfile_name} COMMAND ${CMAKE_BINARY_DIR}/bin/nmodl ${modfile})
  cpp_cc_configure_sanitizers(TEST ${modfile_name})
endforeach()
