=== debian/changelog ===
nmodl (0.5-1) unstable; urgency=medium

  * New upstream release: 0.5
  * Explicitly add some missing Python dependencies
  * Refresh find-packaged-hpc-coding-conventions.patch

 -- Matthias Klumpp <mak@debian.org>  Thu, 02 Feb 2023 22:17:15 +0100

nmodl (0.4-1) unstable; urgency=medium

  * Initial release, required by NEURON 0.8.x

 -- Matthias Klumpp <mak@debian.org>  Thu, 26 Jan 2023 22:54:02 +0100
