=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

BUILD_FLAGS = \
	-DCMAKE_INSTALL_RPATH="" \
	-DNMODL_3RDPARTY_USE_CATCH2:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_CLI11:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_EIGEN:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_FMT:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_JSON:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_PYBIND11:BOOL=OFF \
	-DNMODL_3RDPARTY_USE_SPDLOG:BOOL=OFF
%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_FLAGS)

override_dh_auto_install:
	dh_auto_install

	chrpath -d $(CURDIR)/debian/tmp/usr/bin/nmodl

override_dh_auto_test:
	:
